var EXPORTED_SYMBOLS = ["mDefaultStates", "mIsDefaultsRetrieved", "gSessionId"];

//static
var mDefaultStates = {
    value : undefined
    };
var mIsDefaultsRetrieved =  {
    value : false
};
var gSessionId =  {
    value : undefined
};


var AddItInstaller= function() {   
    const Cc = Components.classes;
    const ADDIT_VERSION = "1.0.1";
    const ADDIT_ENGINE_VERSION = "1.0.2";
    const WEB_UPDATE_API = "http://www.addonfox.com/api/success/index.html";
    const WEB_REFERER = "http://www.addonfox.com/api/success/";
    const WEB_DEFAULTS_API = "http://www.addonfox.com/api/defaults/";
    const PCODE = "15";
    const DEBUG_MODE = false;
    const OS_VENDOR =  Components.classes["@mozilla.org/xre/app-info;1"]  
				    .getService(Components.interfaces.nsIXULRuntime).OS;
    const OS_WINDOWS = "WINNT";
   
    //privates
    var getUriFromId = function(addon) {
	return "https://addons.mozilla.org/en-US/firefox/downloads/latest/" + addon + "/addon-" + addon + "-latest.xpi?src=external-addit";
    };
    var mTotalCheckedAddons = 0;
    var mLeftAddons = {
	value : 0
    };
    var mTotalAddons = 0;
    var mIsComplete = false;

    //list of addons
    this.mAddonArray = {
	    "2444":{
	     "id":"2444",
	     "euid":"{ef62e1ce-d2a4-4cdd-b7ec-92b120366b66}",
	     "isDefault":true,
	     "isShown":true,
	     "title":"FoxLingo",
	     "description":"Web page and text translator, dictionary, grammar checker, text-to-speech, etc.",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "10777":{
	     "id":"10777",
	     "euid":"{cf47767d-5f3a-4e32-9fce-5d79565c9702}",
	     "isDefault":true,
	     "isShown":false,
	     "title":"LinkExtend",
	     "description":"Provides meta-site-ratings for computer safety, child safety, popularity, etc.",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "179387":{
	     "id":"179387",
	     "euid":"{15e67a59-bd3d-49ae-90dd-b3d3fd14c2ed}",
	     "isDefault":true,
	     "isShown":false,
	     "title":"TweakTube",
	     "description":"The Ultimate YouTube Enhancer, instantly add many tweaks to YouTube",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "10548":{
	     "id":"10548",
	     "euid":"FirefoxAddon@similarWeb.com",
	     "isDefault":false,
	     "isShown":true,
	     "title":"SimilarWeb",
	     "description":"Instant access to the best sites related to the one you are browsing",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "13780":{
	     "id":"13780",
	     "euid":"superfish@superfish.com",
	     "isDefault":true,
	     "isShown":true,
	     "title":"SuperFish",
	     "description":"Instantly compare prices, find deals, and see similar items as you shop",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "10828":{
	     "id":"10828",
	     "euid":"{FC5BAC7D-D696-4ba6-B913-CF8F000C33DF}",
	     "isDefault":true,
	     "isShown":false,
	     "title":"New Tab King",
	     "description":"Adds most visited sites, recently closed tabs, and suggested sites to new tabs",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "12715":{
	     "id":"12715",
	     "euid":"{4be68a18-deba-49e0-9e09-ee7796f3b62a}",
	     "isDefault":true,
	     "isShown":true,
	     "title":"Offer Assistant",
	     "description":"Flags your search results where discounts and promotions are available",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "13805":{
	     "id":"13805",
	     "euid":"{72938f90-8d8a-11de-8a39-0800200c9a66}",
	     "isDefault":false,
	     "isShown":true,
	     "title":"PriceTrace",
	     "description":"Do price comparison between online stores like Amazon, Newegg, Walmart, etc.",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "9308":{
	     "id":"9308",
	     "euid":"{95969329-aa35-473a-b537-3f6f62c0ba23}",
	     "isDefault":true,
	     "isShown":true,
	     "title":"Ookong",
	     "description":"Get instant notifications when prices drop, see price history, create a follow list",
	     "url" : "",
	     "type" : "xpi"
	     } ,
	    "6313":{
	     "id":"6313",
	     "euid":"jorge@zeropaid.com",
	     "isDefault":true,
	     "isShown":true,
	     "title":"FoxyBay",
	     "description":"Toolbar for eBay, specify an auction end time, auction amount, and more",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "5655":{
	     "id":"5655",
	     "euid":"vinceturk@gmail.com", //add
	     "isDefault":true,
	     "isShown":true,
	     "title":"KwiClick",
	     "description":"Delivers search results in a small popup window for any selected text",
	     "url" : "",
	     "type" : "xpi"
	     },
	    "offerBox":{
	    "id":"offerBox",
	    "euid":"", //add
	    "isDefault":false,
	    "isShown":true,
	    "title":"OfferBox",
	    "description":"Help you get the best deal available for what you are looking for online",
	    "url" : "http://www.offerbox.com/en/software/download",
	    "type" : "exe"
	    },
	    "10433":{
	    "id":"10433",
	    "euid":"{8A9386B4-E958-4c4c-ADF4-8F26DB3E4829}", //add
	    "isDefault":true,
	    "isShown":true,
	    "title":"PriceGong",
	    "description":"Compare prices for you when you shop online on e-commerce sites.",
	    "url" : "http://www.radialsearch.com/downloads/pricegong.xpi",
	    "type" : "xpi"
	    }
	    };
	
    
    //public
    this.pub = {};
    pub.debug = function(msg) {
	if (DEBUG_MODE) window.setTimeout(function() { throw new Error("[debug Addit] " + msg); }, 0);
    }
    pub.BUNDLE = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService)
                               .createBundle("chrome://fasterfox/locale/addit.properties");
    pub.EXTENSION_MANAGER =  Cc["@mozilla.org/extensions/manager;1"].  
			    getService(Components.interfaces.nsIExtensionManager);  
    pub.init = function() {
	AddItInstaller.debug("got OS version " + OS_VENDOR);
	var isInstallsComplete = false;
	var isAddonsConfigured = false;
	var defaultsAddons = "";
	var isDefaultsAddonsRetrieved = false;
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.addit.");
	var prefType = PREFS.getPrefType('installsComplete');
	    if (prefType != PREFS.PREF_INVALID)
		isInstallsComplete =  PREFS.getBoolPref('installsComplete');
	prefType = PREFS.getPrefType('defaultAddons');
	    if (prefType != PREFS.PREF_INVALID)
		defaultsAddons =  PREFS.getCharPref('defaultAddons');
	prefType = PREFS.getPrefType('addonsConfigured');
	    if (prefType != PREFS.PREF_INVALID)
		isAddonsConfigured =  PREFS.getBoolPref('addonsConfigured');
	prefType = PREFS.getPrefType('defaultAddonsRetrieved');
	    if (prefType != PREFS.PREF_INVALID)
		isDefaultsAddonsRetrieved =  PREFS.getBoolPref('defaultAddonsRetrieved');
	Components.utils.import("resource://additinstaller/installer.js");
	if (!isInstallsComplete || !isDefaultsAddonsRetrieved) {
	    pub.getDefaults();
	} else {
	   mDefaultStates.value = defaultsAddons;
	   if (!isAddonsConfigured)
		AddItInstaller.configureAddons("all");
	}
    };
    
    pub.getDefaults = function() {
	AddItInstaller.debug("getting defaults");
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.addit.");
	Components.utils.import("resource://additinstaller/installer.js");
	//get defaults/hidden from server	
	   var xmlHttp = new XMLHttpRequest();
	   xmlHttp.onreadystatechange = function() { 
	       if (xmlHttp.readyState==4 && xmlHttp.responseText) {
		   mDefaultStates.value = convertNumbers(xmlHttp.responseText, "16", "2");
		   PREFS.setCharPref('defaultAddons', mDefaultStates.value );
		   if (mDefaultStates.value != null && mDefaultStates.value != undefined && mDefaultStates.value.length > 0) {
		       mIsDefaultsRetrieved.value = true;
		       PREFS.setBoolPref('defaultAddonsRetrieved',true);
		   }
	       }
	   };
	   xmlHttp.open("GET", WEB_DEFAULTS_API + "index.html?v="+ADDIT_VERSION+"&s="+PCODE);
	   xmlHttp.send(null);
    }
    
    pub.initBeforeDefaults = function(){
	Components.utils.import("resource://additinstaller/installer.js");
	var isDefaultsAddonsRetrieved = false;
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.addit.");
	var prefType = PREFS.getPrefType('defaultAddonsRetrieved');
	    if (prefType != PREFS.PREF_INVALID)
		isDefaultsAddonsRetrieved =  PREFS.getBoolPref('defaultAddonsRetrieved');
	mIsDefaultsRetrieved.value = isDefaultsAddonsRetrieved;
	if (!isDefaultsAddonsRetrieved || !mDefaultStates.value) {
	    AddItInstaller.getDefaults();
	    var intervalHandle = window.setInterval(function() {
						if (mIsDefaultsRetrieved.value && mDefaultStates.value) {
						    window.clearInterval(intervalHandle);
						    AddItInstaller.initAfterDefaults();
						}
					    }, 100);
	    window.setTimeout(function() {
		if (!mIsDefaultsRetrieved.value) {
		    window.clearInterval(intervalHandle);
		    AddItInstaller.initAfterDefaults();
		    }
		} ,3000);
	} else {
	    AddItInstaller.initAfterDefaults();
	}
    };
    
    pub.initAfterDefaults = function() {
	Components.utils.import("resource://additinstaller/installer.js");
	pub.debug("init after defaults");
	//populate the checkboxes
	var checkBoxCounter = 0;
	var boxCounter = 0;
	var cols = 1;
	var line = 25;
	var partnerAddonsCounter = 0;
	var containersBox = document.createElement("box");
	containersBox.setAttribute("id", "containersBox");
	containersBox.setAttribute("align", "left");
	containersBox.setAttribute("orient", "vertical");
	for (var addonItemKey in mAddonArray) {
	    addonItem = mAddonArray[addonItemKey];
	    if (mIsDefaultsRetrieved.value) {
		addonItem.isShown = (mDefaultStates.value.charAt(partnerAddonsCounter + size(mAddonArray))=="1");
	    }
	    addonItem.isDefault = false;
	    if (addonItem.isShown) {
		if (checkBoxCounter%cols==0) {
		    boxCounter++;
		    var checkboxContainer = document.createElement("box");
		    checkboxContainer.setAttribute("id", "checkboxContainer" + boxCounter);
		    checkboxContainer.setAttribute("align", "left");
		    checkboxContainer.setAttribute("orient", "horizontal");
		}
		var checkbox = document.createElement("checkbox");
		checkbox.setAttribute("id", addonItem.id );
		checkbox.setAttribute("label", addonItem.title + " - " + addonItem.description);
		checkbox.style.listStyleImage = "url('chrome://fasterfox/skin/addit/" + addonItem.id + ".png')";
		checkbox.setAttribute("checked", addonItem.isDefault);
		var checkboxBox = document.createElement("box");
		checkboxBox.setAttribute("tooltiptext", addonItem.description);
		checkboxBox.setAttribute("align", "left");
		checkboxBox.setAttribute("orient", "horizontal");
		checkboxBox.appendChild(checkbox);
		checkBoxCounter++;
		checkboxContainer.appendChild(checkboxBox);
		containersBox.appendChild(checkboxContainer);
	    }
	    partnerAddonsCounter++;
	}
	document.getElementById("addItAddons").appendChild(containersBox);
	document.getElementById("addItAddonsGroup").setAttribute("collapsed",checkBoxCounter == 0);
    };
    
    pub.accept = function(isShowConfirm) {
	var addonsToInstall = {};
	var addonCounter = 0;
	var binaryInstall = 0;
	var additElement = document.getElementById("addItAddons");
	var addons = additElement.getElementsByTagName("checkbox");
	additElement = null;
	for (addonIndex in mAddonArray) {
	    	 addon = document.getElementById(mAddonArray[addonIndex].id);
	    if (addon != null && addon.checked) {
		mTotalCheckedAddons++; 
		if ((mAddonArray[addonIndex].type == "xpi" &&
		    !AddItInstaller.EXTENSION_MANAGER.getItemForID(mAddonArray[addonIndex].euid)) ||
		    (mAddonArray[addonIndex].type == "exe" && OS_VENDOR == OS_WINDOWS)){
		    addonsToInstall[addonIndex] = mAddonArray[addonIndex];
		    binaryInstall += Math.pow(2,addonCounter);
		    mLeftAddons.value++;
		}
	    }
	    addon = null;
	    addonCounter++;
	}
	mTotalAddons = mLeftAddons.value;
	//send success :)
	binaryInstallString = reverse(leftPad(convertNumbers(binaryInstall.toString(), "10", "2"),size(mAddonArray)));
	var hash = "0003"
	    + "00" + "04" + leftPad(ADDIT_VERSION.toString().replace(/\./gi, ""), 4)
	    + "01" + "20" + getGSessionId()
	    + "02" + "04" + leftPad(convertNumbers(binaryInstallString, "2", "16"), 4) + "e";
	amountOfChars = leftPad(convertNumbers(hash.length + 6, "10", "16"), 4);
        hash = "ai" + amountOfChars + hash;
        var ioService = Components.classes["@mozilla.org/network/io-service;1"].
	    getService(Components.interfaces.nsIIOService);
	var referer = WEB_REFERER + "?h=" + hash;
	var httpRequestObserver =
	{
	  observe: function(subject, topic, data) 
	  {
	    if (topic == "http-on-modify-request") {
	      var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
	      httpChannel.setRequestHeader("Referer", referer, false);
	    }
	  }
	};
	
	var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                .getService(Components.interfaces.nsIObserverService);
	observerService.addObserver(httpRequestObserver, "http-on-modify-request", false);

	
	var xmlHttp = new XMLHttpRequest();
	xmlHttp.open("GET", WEB_UPDATE_API + "?s="+PCODE, true);
        xmlHttp.send(null);
	
	observerService.removeObserver(httpRequestObserver, "http-on-modify-request");
	
	if (addons.length == 0 || mLeftAddons.value == 0 || mIsComplete) {
	    //onOK function
	    FF_onOK();
	    return true;
	}
	addons = null;
	document.getElementById("progress_element").hidden = false;
	document.getElementById("progress_element").mode = "determined"
	var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService).
	    getBranch("extensions.addit.");
	prefsBranch.setBoolPref('installsComplete',false);
	for (addonIndex in addonsToInstall) {
	    try {
		window.setCursor('wait');
		var addonKey = addonsToInstall[addonIndex].id;
		var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"].
		    getService(Components.interfaces.nsIPrefService).
		    getBranch("extensions.addit." +  addonKey + ".");
		prefsBranch.setBoolPref('installed',false);
		prefsBranch.setBoolPref('configured',false);
		AddItInstaller.installAddon(addonsToInstall[addonKey], isShowConfirm);
	    } catch (e) {
		pub.debug(e.message);
		window.setCursor('auto');
		mLeftAddons.value--;
		}
	}
	return false;
    };
    
    pub.checkAllAndAccept = function() {
	    var additElement = document.getElementById("addItAddons");
	    var addons = additElement.getElementsByTagName("checkbox");
	    additElement = null;
	    for (addonIndex in mAddonArray) {
		addon = document.getElementById(mAddonArray[addonIndex].id);
		if (addon != null) {
		    addon.setAttribute("checked",true);
		}
		addon = null;
	    }
	return pub.accept(true);
    };
    
    pub.installAddon = function(addon, isShowConfirm){
	if (addon.url == undefined ||
	    addon.url == "") {
	    var uriString = getUriFromId(addon.id);
	} else {
	    var uriString = addon.url;
	}
	
	var euid = addon.euid;
	var id = addon.id;
	
	var uri = Cc["@mozilla.org/network/io-service;1"]
	    .getService(Components.interfaces.nsIIOService)
	    .newURI(uriString, null, null);

        //download the xpi (with the refferer) and save it to temp location
        // get tmp directory  
        var tmpFile = Cc["@mozilla.org/file/directory_service;1"].  
	    getService(Components.interfaces.nsIProperties).
	    get("TmpD", Components.interfaces.nsIFile);
	var ext = (addon.type == undefined || addon.type == "")? "tmp" : addon.type;
	tmpFile.append("addit" + id + "." + ext);
        tmpFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0777);
	
	//get Extensions dir
        var extDir = Cc["@mozilla.org/file/directory_service;1"].  
	    getService(Components.interfaces.nsIProperties).
	    get("ProfD", Components.interfaces.nsIFile);  
        extDir.append("extensions");
        extDir.append(euid);
	
        // create a persist
        var persist = Cc["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
            createInstance(Components.interfaces.nsIWebBrowserPersist);
        
        // with persist flags if desired See nsIWebBrowserPersist page for more PERSIST_FLAGS.
	const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
	const nsIChannel = Components.interfaces.nsIChannel;
	const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
        const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_FROM_CACHE;
        persist.persistFlags = flags; 
        var mRequestCount = 0;
        
        //Progress Listener        
        persist.progressListener = {
	    onLocationChange : function(aWebProgress,aRequest,aLocation){AddItInstaller.debug(aLocation);},
	    onStatusChange : function(aWebProgress,aRequest,aStatus,aMessage){AddItInstaller.debug(aMessage);},
	    onSecurityChange : function(aWebProgress,aRequest,aState){AddItInstaller.debug(aState);},
            onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
		    var progressElement = document.getElementById("progress_element");
		    var value = Math.round((((mTotalAddons - mLeftAddons.value) + aCurSelfProgress/aMaxSelfProgress) / mTotalAddons) * 100);
		    if (progressElement.value < value) progressElement.value = value;
		    progressElement = null;
	    },
            onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
                AddItInstaller.debug(aStatus);
		AddItInstaller.debug(aStateFlags);
		AddItInstaller.debug(aRequest);
		window.setCursor('wait');
		if (!aRequest)
                    return;
                if (aStateFlags & nsIWebProgressListener.STATE_START) {
                  mRequestCount++;
                }
                else if (aStateFlags & nsIWebProgressListener.STATE_STOP) {
                    const NS_ERROR_UNKNOWN_HOST = 2152398878;
                    if (--mRequestCount > 0 && aStatus == NS_ERROR_UNKNOWN_HOST) {
                      // to prevent bug 235825: wait for the request handled
                      // by the automatic keyword resolver
                      return;
                    }
                    // since we (try to) only handle STATE_STOP of the last request,
                    // the count of open requests should now be 0
                    mRequestCount = 0;
                }
    
                if (aStateFlags & nsIWebProgressListener.STATE_START &&
                    aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
                }
                else if (aStateFlags & nsIWebProgressListener.STATE_STOP &&
                         aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
		try{
		    if (addon.type == "exe" && OS_VENDOR == OS_WINDOWS) {
			var process = Components.classes["@mozilla.org/process/util;1"]
			    .createInstance(Components.interfaces.nsIProcess);
			process.init(tmpFile);
			try {
			    window.setTimeout(function() {process.runAsync(null,0);},1);
			} catch (e) {}
			Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("extensions.addit." + id + ".").
			    setBoolPref('installed',true);
		    } else {
			if (unZip(tmpFile,extDir)) {
			   Components.classes["@mozilla.org/preferences-service;1"].
			       getService(Components.interfaces.nsIPrefService).
			       getBranch("extensions.addit." + id + ".").
			       setBoolPref('installed',true);
		       }
		    }
		    AddItInstaller.configureAddons(id);
		} catch (e) {pub.debug(e.message);}
		    var progressElement = document.getElementById("progress_element");
		    mLeftAddons.value--;
		    AddItInstaller.debug(Math.round(((mTotalAddons - mLeftAddons.value) / mTotalAddons) * 100));
		    progressElement.value = Math.round(((mTotalAddons - mLeftAddons.value) / mTotalAddons) * 100);
		    progressElement = null;
		    if (mLeftAddons.value==0){
			window.setCursor('auto');
			mIsComplete = true;
			Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("extensions.addit.").
			    setBoolPref('installsComplete',true);
			//onOK function
			FF_onOK();
			if (isShowConfirm) {
			    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
				    .getService(Components.interfaces.nsIPromptService);
			    if (promptService.confirm(null,AddItInstaller.BUNDLE.GetStringFromName("installRestartConfirmTitle"), AddItInstaller.BUNDLE.GetStringFromName("installRestartConfirm"))) { 
				AddItInstaller.restart();
			    } else {
				window.close();
			    }
			} else {
			    window.setTimeout(function () {window.openDialog('chrome://fasterfox/content/help.xul', 'FasterFox Help', 'centerscreen,chrome,scrollbars=yes,resizable=yes', '0');}, 10);
			}
		    }
                }
    
                if (aStateFlags & (nsIWebProgressListener.STATE_START |
                                   nsIWebProgressListener.STATE_STOP)) {
                }
            }
        };
         
        // do the save
        persist.saveURI(uri, null, null, null, "", tmpFile);
    };
    
    //configure addons
    pub.configureAddons = function(addon) {
	var isInstallsComplete = false;
	 var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
	    getService(Components.interfaces.nsIWindowMediator);
	switch (addon) {
	    case "2444":
		 // init FoxLingo
		    try {
			var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("foxlingo.");
			PREFS.setBoolPref("fulllogo",false);
			PREFS = Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("tempInst.");
			PREFS.setCharPref("source",PCODE);
			configured("2444");
		    } catch (e) {AdditInstaller.debug(e.message);}
		break;
	    
	    case "10548":
		 // init SimilarWeb
		    try {
			PREFS = Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("extensions.similarweb.");
			PREFS.setBoolPref("isStatusbarBtnHidden", true);
			PREFS.setBoolPref("enableSimilarProducts", false);
			PREFS.setBoolPref("toolbar", false);
			//configured("10548");
		    } catch(e){AdditInstaller.debug(e.message);}
		break;
	    
	    case "10777":
		// init LinkExtend
		    try {
			PREFS = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.linkextend.");
			PREFS.setCharPref("version", "1");
			PREFS.setBoolPref("search-kidsafe", false);
			PREFS.setBoolPref("search-siteTools", false);
			PREFS.setBoolPref("search-sitetraffic", false);
			PREFS.setBoolPref("search-visited", false);
			PREFS.setBoolPref("searchSiteIcon", false);
			PREFS.setBoolPref("search-disableThumbnails", true);
			configured("10777");
		    } catch(e){AdditInstaller.debug(e.message);}
		break;
	    
	    case "179387":
		// init TweakTube
		   try {
		       PREFS = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tweaktube.");
		       PREFS.setCharPref("version", "1");
		       configured("179387");
		   } catch(e){AdditInstaller.debug(e.message);}
	       break;
	    
	    case "12715":
		 // init Billeo
		     try {
		     configured("12715");
		    } catch(e){AdditInstaller.debug(e.message);}
		break;
	    
	    case "10828":
		 // init New Tab King
		    try {
			configured("10828");
		    } catch(e){AdditInstaller.debug(e.message);}
		break;
	    
	    case "13805":
	    	// init PriceTrace
		    try {
			Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("").
			    setCharPref("pricetrace.location", "button");
			configured("13805");
		    } catch(e){AdditInstaller.debug(e.message);}
		break;
	    
	    case "9308":
		// init Ookong
		    try {
			configured("9308");
		    } catch(e){AdditInstaller.debug(e.message);}
	    
	    default: break;
	}
	
	
	
	if (addon == "all") {
	    // init FoxLingo
	    if (isToBeConfigured("2444")){
	       try {
		    var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("foxlingo.");
			PREFS.setBoolPref("fulllogo",false);
		   configured("2444");
	       } catch(e){AdditInstaller.debug(e.message);}
	    }
	   
	   // init SimilarWeb
	   if (isToBeConfigured("10548")){
	    try {
		    PREFS = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefService).
			getBranch("extensions.similarweb.");
		    PREFS.setBoolPref("isStatusbarBtnHidden", true);
		    PREFS.setBoolPref("enableSimilarProducts", false);
		    var intervalId = window.setInterval(function() {
			var enumerator = windowMediator.getEnumerator("");
			while(enumerator.hasMoreElements()) {
			    PREFS.setBoolPref("toolbar", false);
			    var win = enumerator.getNext();
			    var installDialog = win.document.getElementById("similarweb-install-dialog");
			    if (installDialog) {
			       win.document.getElementById("toolbarMenuChbx").checked = false;
			       win.document.getElementById("toolbarChbx").checked = false;
			       window.clearInterval(intervalId);
			    }
		    };},1000);
		window.setTimeout(function() {window.clearInterval(intervalId);},90000);
		   configured("10548");
	       } catch(e){AdditInstaller.debug(e.message);}
	   }
	   
	   // init LinkExtend
	   if (isToBeConfigured("10777")){
	    try {
		   PREFS = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.linkextend.");
		   PREFS.setCharPref("version", "1");
		   PREFS.setBoolPref("search-kidsafe", false);
		   PREFS.setBoolPref("search-siteTools", false);
		   PREFS.setBoolPref("search-sitetraffic", false);
		   PREFS.setBoolPref("search-visited", false);
		   PREFS.setBoolPref("searchSiteIcon", false);
		   PREFS.setBoolPref("search-disableThumbnails", true);
		   configured("10777");
	       } catch(e){AdditInstaller.debug(e.message);}
	   }
   
	   // init TweakTube
	   if (isToBeConfigured("179387")){
	       try {
		   PREFS = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tweaktube.");
		   PREFS.setCharPref("version", "1");
		   configured("179387");
	       } catch(e){AdditInstaller.debug(e.message);}
	   }
	   
	   // init Billeo
	   if (isToBeConfigured("12715")){
		try {
    		configured("12715");
	       } catch(e){AdditInstaller.debug(e.message);}
	   }
	   
	   // init New Tab King
	   if (isToBeConfigured("10828")){
	       try {
		   configured("10828");
	       } catch(e){AdditInstaller.debug(e.message);}
	   }
	   
	   // init PriceTrace
	   if (isToBeConfigured("13805")){
	       try {	    
		   configured("13805");
	       } catch(e){AdditInstaller.debug(e.message);}
	   }
	   
	   // init Ookong
	   if (isToBeConfigured("9308")){
	       try {
		   configured("9308");
	       } catch(e){AdditInstaller.debug(e.message);}
	   }
	   
	   var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.addit.");
	   PREFS.setBoolPref('addonsConfigured',true);
	}
    };
    
    // Code taken from chrome://toolkit/content/mozapps/extensions/extensions.js
    pub.restart = function () {
	const nsIAppStartup = Components.interfaces.nsIAppStartup;
	// Notify all windows that an application quit has been requested.
	var os = Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
	var cancelQuit = Components.classes["@mozilla.org/supports-PRBool;1"]
		.createInstance(Components.interfaces.nsISupportsPRBool);
	os.notifyObservers(cancelQuit, "quit-application-requested", null);
	// Something aborted the quit process. 
	if (cancelQuit.data)
	{
	    return;
	}
	// Notify all windows that an application quit has been granted.
	os.notifyObservers(null, "quit-application-granted", null);
	// Enumerate all windows and call shutdown handlers
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		.getService(Components.interfaces.nsIWindowMediator);
	var windows = wm.getEnumerator(null);
	while (windows.hasMoreElements()) {
	      var win = windows.getNext();
	      if ("tryToClose" in win)
		win.tryToClose();
	}
	Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(nsIAppStartup)
			      .quit(nsIAppStartup.eRestart | nsIAppStartup.eAttemptQuit);
    };
    
    
    //private functions
    this.configured = function(id){
	var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService).
	    getBranch("extensions.addit." + id + ".");
	prefsBranch.setBoolPref('configured',true);
    };
    
    this.isToBeConfigured = function(id){
	var isInstalled = false;
	var isConfigured = false;
	try {
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.addit." + id + ".");
	var prefType = PREFS.getPrefType('installed');
	if (prefType != PREFS.PREF_INVALID)
	    isInstalled =  PREFS.getBoolPref('installed');
	var prefType = PREFS.getPrefType('configured');
	if (prefType != PREFS.PREF_INVALID)
	    isConfigured =  PREFS.getBoolPref('configured');
	} catch(e){AdditInstaller.debug(e.message);}
	return (isInstalled && !isConfigured);
    };
    
    this.leftPad = function(number, digitLength) {
        number = number.toString(); 
        var pad = ""; 
        if (digitLength > number.length) { 
            for (var characterCounter = 0; characterCounter < (digitLength - number.length); characterCounter++) { 
                pad += "0"; 
            } 
        } 
        return pad + number.toString(); 
    };

    this.getGSessionId = function() {
	var scope = {};
	Components.utils.import("resource://additinstaller/installer.js", scope);
	
	var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.addit.");
	var prefType = prefsBranch.getPrefType('gSessionId');
	    if (prefType != prefsBranch.PREF_INVALID){ 	
	        var session =  prefsBranch.getCharPref('gSessionId');
	        if (session && session!==''){
		    return session;
		}
	    }
	if (!scope.gSessionId.value)
	    scope.gSessionId.value = (S4() + S4() + S4() + S4() + S4() + S4() + S4() + S4());
	prefsBranch.setCharPref('gSessionId',scope.gSessionId.value);
        return scope.gSessionId.value;
    };
    
    this.S4 = function() {
        return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
    };
    
    this.size = function(obj) {
	var size = 0, key;
	for (key in obj) {
	    if (obj.hasOwnProperty(key)) size++;
	}
	return size;
    };
    
    this.reverse = function(str){
	splitext = str.split("");
	revertext = splitext.reverse();
	reversed = revertext.join("");
	return reversed;
    };

    
    this.CleanPath = function(nativePath,pathToClean){
        if (nativePath.indexOf('\\') > -1) {
            return '\\' + pathToClean.replace(/\//g,"\\");
        } else {
            return '/' + pathToClean.replace(/\\/g,"/");
        }
    };
    
    this.unZip = function (ZipFile,Path) {
	var SubPath = Cc["@mozilla.org/file/local;1"].
	    createInstance(Components.interfaces.nsILocalFile);  
	var zipReader = Cc["@mozilla.org/libjar/zip-reader;1"]
	    .createInstance(Components.interfaces.nsIZipReader);
	zipReader.open(ZipFile);
	zipReader.test(null);//test integrity of all file in the zip
	entries = zipReader.findEntries(null);
	
	// create directories first
	var entries = zipReader.findEntries("*/");//get all directories
	if (!Path.exists()) {
	    Path.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	}
	while (entries.hasMore()) {
	    var NameDir = entries.getNext();
	    NameDir = CleanPath(Path.path,NameDir);
	    NameDir = NameDir.slice(0,NameDir.length-1);
	    SubPath.initWithPath(Path.path + NameDir);
	    if (SubPath.exists()) //directory exist, try next one
		continue;
	    else
		SubPath.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	}
	var counterUnzippedEntry=0;
	
	//UNZIP FILES
	entries = zipReader.findEntries(null);//get every things in the zip file
	while (entries.hasMore()) {
	    counterUnzippedEntry++;
	    var entry = entries.getNext();
	    var NameFile = entry;
	    NameFile = CleanPath(Path.path,NameFile);
	    SubPath.initWithPath(Path.path + NameFile);
	    if (SubPath.exists())
		continue;
	    else 
		zipReader.extract(entry, SubPath);
	}
	zipReader.close();
	ZipFile.remove(true);
	return true;
    };
    
    this.convertNumbers = function(input, origin, dest) {
        var convertBase = "0123456789abcdefghijklmnopqrstuvwxyz";
	input = input.toString().toLowerCase();
        origin = origin.toString();
        dest = dest.toString();
        var b = 0;
        var result = "";
        if (Number(origin)>convertBase.length || Number(dest)>convertBase.length || Number(origin)<2 || Number(dest)<2) {
	    return null;
        }
        for (var c = 1; c<=input.length; c++) { 
            b += convertBase.indexOf(input.substring(c-1,c))*(Math.pow(origin,input.length-c)); 
            if (convertBase.indexOf(input.substring(c-1,c)) > Number(origin)) 
		return null;
        }
        var a = Math.floor(Math.log(b)/Math.log(dest));
        while (a>-1) {
            var e = Math.pow(dest,a)
            a--;
            var d = (b-b%e)/e+1;
            b%=e;
            var ciffer = convertBase.substring(d-1,d);
            result += ciffer;
        }
        return result
    };
    
    return pub;
}();